#COMPILE EXE
DEFSNG a - z

FUNCTION ASIN(X) : ASIN = ATN((X/SQR(1-X*X))) + 1.5708*(1-SGN(X)) : END FUNCTION

FUNCTION PBMAIN () AS LONG

   GOTO 1090

140
    ER=(SQR(2*LE/LA)-B/LA)^2*(2*LE/LA-1)
    ER=ER-(SQR(3*K*LA/LE)-A/LA)^2*(4*K*LA/(3*LE)-1)
RETURN

NextWG:
    FOR T%=1 TO 12    'Find suitable waveguide
         WG% = VAL(READ$(1 + 5 * T%))
         A = VAL(READ$(2 + 5 * T%))
         B = VAL(READ$(3 + 5 * T%))
         FL = VAL(READ$(4 + 5 * T%))
         FH = VAL(READ$(5 + 5 * T%))
         IF F>=1000!*FL THEN IF F<=1000!*FH THEN 230
    NEXT T%
    PRINT
    PRINT
    PRINT"Wave guide data not available for"
    PRINT "this frequency":GOTO 1170
230 PRINT
    PRINT USING$("          Recommended waveguide WG##",WG%)
    PRINT "          Frequency range ";FL;" TO ";FH;" GHz"
    PRINT USING$( "          Dimensions A = ###.# mm     B = ###.# mm";A * 25.4 , b * 25.4)
    PRINT "          Is this OK  (Y/n)   ";P$;
    WHILE NOT INSTAT:WEND
    PRINT
    P$=UCASE$(INKEY$)
    IF P$<>"N" THEN 360
290 PRINT
    INPUT "          Which waveguide size is to be used  ";W%
    FOR T%=1 TO 12
         WG% = VAL(READ$(1 + 5 * T%))
         A = VAL(READ$(2 + 5 * T%))
         B = VAL(READ$(3 + 5 * T%))
         FL = VAL(READ$(4 + 5 * T%))
         FH = VAL(READ$(5 + 5 * T%))
         IF W%=WG% THEN T%=12
         IF W%=WG% THEN 360
    NEXT T%
    PRINT:PRINT"Waveguide data not available":GOTO 290
360 A=.0254*A : B=.0254*B
RETURN



380 Z2=Z/2
    C=0:S=0
    FOR I=1 TO 20
        Y1=Z2*X(I)+Z2
        Y2=-Z2*X(I)+Z2
        C1=COS(P2*Y1*Y1)
        C2=COS(P2*Y2*Y2)
        S1=SIN(P2*Y1*Y1)
        S2=SIN(P2*Y2*Y2)
        C=C+W(I)*(C1+C2)
        S=S+W(I)*(S1+S2)
    NEXT I
    C=Z2*C:S=Z2*S
RETURN


520       'Read Gauss Integral Data.  Starts at item 61 after waveguide data
    FOR I%=1 TO 20
        X(I%) = VAL(READ$(I% * 2 + 59))      'First data item is no. 61
        W(I%) = VAL(READ$(I% * 2 + 60))
    NEXT I%
RETURN


1090 CLS
    PI=3.1415926#:P2=PI*.5
    DIM X(20),W(20)
    PRINT
    PRINT"             GENERAL HORN DESIGN PACKAGE"
    PRINT"             ---------------------------"
    COLOR 8
    PRINT "Original Software Design - Barry Chambers G8AGN"
    PRINT "Graphics and conversion TO 32 BIT PowerBasic - Andy Talbot G4JNT"
    PRINT
    COLOR 7
1120 PRINT"  OPTIONS ARE:":PRINT
    COLOR 14:PRINT"         O";:COLOR 7:PRINT"ptimum gain horns"
    COLOR 14:PRINT"         S";:COLOR 7:PRINT"ectoral horns   O/S   ";
1145 WHILE NOT INSTAT:WEND
    ik$ = UCASE$(INKEY$)
    c=INSTR("OS",ik$)
    IF c=0 THEN GOTO 1145
    COLOR 13 : PRINT  ik$ : COLOR 7
    PRINT
1170 INPUT "         Frequency (GHz)     ",F
    IF f=0 THEN LOCATE csrlin-1,1:GOTO 1170
    f=f*1000:LA=299.79/F
1180 INPUT "         Required gain (dB)  " ,GD
    IF gd=0 THEN LOCATE csrlin-1,1:GOTO 1180
    ON c GOTO OptGain , DoSectoral

OptGain:
    PRINT

    PRINT"          ------------------------"
    PRINT"          Optimum gain horn design"
    PRINT
    COLOR 14
    PRINT"          P"; :COLOR 7 : PRINT "yramidal or ";
    COLOR 14 : PRINT "C"; :COLOR 7 : PRINT "onical horn (P/C)      ";

1240 WHILE NOT INSTAT:WEND
    T$=UCASE$(INKEY$)
    IF T$<>"C" AND T$<>"P" THEN 1240
    COLOR 13 : PRINT t$ : COLOR 7
    G=10^(.1*GD)
    K=(G/15.7497)^2
    IF T$="C" THEN 1860
    GOSUB NextWG
    S=.1:LS=0
    LE=.001
    GOSUB 140
    ES=ER:E=ER

1310 FOR L=1 TO 50
        LE=S*L+LS
        GOSUB 140
        IF (ES*ER)<0 THEN L=50
        IF (ES*ER)<0 THEN 1360
        ES=ER
1360 NEXT L
    IF S<.000001 THEN 1400
    LE=LE-S:S=.1*S:LS=LE:ES=E
    GOTO 1310

1400 LH=K*LA*LA/LE
    HA=SQR(3*LH*LA)
    HB=SQR(2*LE*LA)
    PRINT:PRINT"Horn mouth dimensions "
    PRINT
    PRINT USING$( "           A = ###.# mm";1000*HA)
    PRINT USING$( "           B = ###.# mm";1000*HB)
    AX=SQR(LH*LH-.25*HA*HA)
    AX=AX-AX*A/HA
    PRINT:PRINT USING$( "Axial length = ####.# mm";1000*AX)
    TE=LE-LE*B/HB
    TH=LH-LH*A/HA
    PRINT
    PRINT USING$( "E-Plane flare slant length = ####.# mm";1000*TE)
    PRINT USING$( "H-Plane flare slant length = ####.# mm";1000*TH)
    GC=8.08+10*LOG(HA*HB/(LA*LA))/LOG(10)
    PRINT
    PRINT USING$( "Calculated optimum gain ##.## dB";GC)
    PRINT"Approximate 3 dB beamwidths"
    E3=54*LA/HB:H3=79*LA/HA
    PRINT USING$( "  E-PLANE = ###.#";E3)
    PRINT USING$( "  H-PLANE = ###.#";H3):PRINT

    X0 = 30  :  X1 = 70 :  X2 = 95  : X3 = 100         'Pyramid horn image
    Y0 = 30  :  Y1 = 60 :  Y2 = 100 : Y3 = 97
    title$ = USING$("Optimum Gain Pyramidal ###.## GHz  WG##  Gain ##.# dB    Beamwidths  E ~ ###.#   H ~ ###.#",F/ 1000,wg%,GC, E3, H3)
    lsidea = SQR(((ha - a) / 2) ^ 2 + te ^ 2)
    lsideb = SQR(((hb - b) / 2) ^ 2 + th ^ 2)    'both these should be the same!!
    GOSUB drawing
    GOSUB cutting
    PRINT "------------------------------------"

    PRINT "  [esc] to end"
    DO
        ik$ = WAITKEY$
        IF ik$ = CHR$(27) THEN EXIT LOOP
    LOOP
    END
1600
    PRINT:INPUT"Lower frequency limit (GHz) ";BL:bl=bl*1000
    IF bl=0 THEN LOCATE csrlin-2,1:GOTO 1600
    IF BL>=1000!*FL THEN 1640
    PRINT:PRINT"WAVEGUIDE OPERATING BELOW RECOMMENDED"
    PRINT:PRINT"FREQUENCY LIMIT ( ";FL;" GHz )."
    PRINT"IS THIS OK (Y/n) "
    WHILE NOT INSTAT:WEND
    t$=UCASE$(INKEY$)
    IF T$="N" THEN 1600

1640
    PRINT:INPUT"Upper frequency limit (GHz) ";BH:bh=bh*1000
    IF bh=0 THEN LOCATE csrlin-2:GOTO 1640
    IF BL<=1000!*FH THEN 1680
    PRINT:PRINT"WAVEGUIDE OPERATING ABOVE RECOMMENDED"
    PRINT:PRINT"FREQUENCY LIMIT ( ";FH;" GHz )."
    PRINT"IS THIS OK (Y/n) "
    WHILE NOT INSTAT:WEND
    t$=UCASE$(INKEY$)
    IF T$="N" THEN 1640

1680
    BL=50*INT(BL/50)
    BH=50*INT(BH/50)+50
    PRINT:PRINT"Rounded frequency limits"
    PRINT:PRINT BL/1000;" - ";BH/1000;" GHz"
    PRINT:PRINT" GHz";TAB(24);"dB"
    PRINT" ---";TAB(24);"--":PRINT
    GOSUB 520
    FOR J=0 TO 100
            F=BL+J*50
            IF F>BH THEN EXIT FOR
            LA=299.7/F
            U1=SQR(LA*LH)/HA:U2=1/SQR(2)
            Z=(U1+1/U1)*U2:GOSUB 380
            CU=C:SU=S
            Z=(U1-1/U1)*U2:GOSUB 380:CV=C:SV=S
            Z=HB/SQR(2*LA*LE):GOSUB 380
            G=8*PI*LE*LH*(C*C+S*S)*((CU-CV)^2+(SU-SV)^2)/(HA*HB)
            PRINT USING$( "##.##                ##.##";F/1000,10*LOG(G)/LOG(10))
        NEXT J
    WHILE NOT INSTAT:WEND
    END

1860
    C=LA*10^(.05*(GD+2.82))
    D=C/PI
    L=D*D/(3*LA)
    PRINT
    PRINT"          OPTIMAL GAIN CONICAL HORN DESIGN"
    PRINT"          --------------------------------"
    PRINT
    PRINT USING$("Aperture diameter  = ###.# mm";1000*D)
    PRINT USING$("Flare slant lengh  = ###.# mm";1000*L)
    E3=INT(60*LA/D+.5)
    H3=INT(70*LA/D+.5)
    PRINT:PRINT"Approximate 3dB beamwidths:"
    PRINT USING$( "   E - plane = ###";E3)
    PRINT USING$( "   H - plane = ###";H3) :PRINT
    CutoutDia = 2 * L
    CutoutAngle = 360 * D / 2 / L
    PRINT
    COLOR 3
    PRINT USING$("Cutting radius     ####.# mm",L * 1000)
    PRINT USING$("Metal segment angle  ###.# (cutout ###.#) ",CutOutAngle, 360 - CutOutAngle)
    COLOR 7
    title$ = USING$("Optimum Gain Conical ###.## GHz    Gain ##.# dB    Beamwidths  E ~ ###.#   H ~ ###.#",F/ 1000,GD, E3, H3)
    PRINT "------------------------------------"
    GOSUB drawcone
    GOSUB CutCone
    PRINT "  [esc] to end"
    DO
        ik$ = WAITKEY$
        IF ik$ = CHR$(27) THEN EXIT LOOP
    LOOP
    END

DoSectoral:
    PRINT
    PRINT"        SECTORAL HORN DESIGN"
    PRINT"        --------------------"
2060 PRINT"  Options are:":PRINT
    COLOR 14:PRINT "          E";:COLOR 7:PRINT" - plane flare"
    COLOR 14:PRINT "          H";:COLOR 7:PRINT" - plane flare           ";
    WHILE NOT INSTAT:WEND
    PRINT
    c=INSTR("EH",UCASE$(INKEY$))
    IF C=0 THEN GOTO 2060
    GOSUB NextWG
    IF C=2 THEN 2270

    HB=LA*LA*10^(.1*(GD-9.08))/A
    HA=A
    LE=SQR(.5*HB*HB/LA)
    PRINT "       -----------------"
    COLOR 15
    PRINT "       E- Plane Sectoral" : COLOR 7
    PRINT "Horn mouth dimensions:"
    PRINT
    PRINT USING$( "     A = ###.#";1000*HA)
    PRINT USING$( "     B = ###.#";1000*HB)
    AX=SQR(LE*LE-.25*HB*HB)
    AX=AX-AX*B/HB
    PRINT:PRINT USING$( "          Horn axial length = ###.# mm";1000*AX)
    TE=LE-LE*B/HB:TH=AX
    PRINT
    PRINT USING$( "          E plane flare slant length = ###.# mm";1000*TE)
    PRINT USING$( "          H plane length               ###.# mm";1000*TH)
    GOSUB 520
    Z=HB/SQR(2*LA*LE):GOSUB 380
    GC=64*HA*LE*(C*C+S*S)/(PI*LA*HB)
    PRINT
    PRINT USING$( "          Calculated gain              ##.## dB";10*LOG10(gc))
    beamwidth = 180 / pi * ASIN(LA/ HB)
    bwnarrow =  300 / F * 70 / HA
    PRINT USING$( "          Beamwidth ~ #.###",beamwidth)

    X0 = 30  :  X1 = 40 :  X2 = 100  : X3 = 106         'E plane image
    Y0 = 30  :  Y1 = 60 :  Y2 = 100 : Y3 = 97
    title$ = USING$("E-Plane Sectoral  ###.## GHz  WG##   Gain ##.# dB       Beamwidth H  ~ ##   E ~ ###",F/ 1000, WG%,10*LOG10(gc),beamwidth, bwnarrow)
    lsidea = SQR(((ha - a) / 2) ^ 2 + te ^ 2)
    lsideb = SQR(((hb - b) / 2) ^ 2 + th ^ 2)    'both these should be the same!!
    GOSUB drawing
    GOSUB cutting
    PRINT "------------------------------------"
    PRINT "Any key to continue"
    PRINT "  [esc] to end"
    DO
        ik$ = WAITKEY$
        IF ik$ = CHR$(27) THEN EXIT LOOP
    LOOP
    END

2270 HA=LA*LA*10^(.1*(GD-9.08))/B
    HB=B
    LH=SQR(HA*HA/LA/3)
    PRINT "     -----------------"
    COLOR 15
    PRINT "     H- Plane Sectoral" : COLOR 7
    PRINT"Horn mouth dimensions:"
    PRINT
    PRINT USING$( "     A = ###.# mm";1000*HA)
    PRINT USING$( "     B = ###.# mm";1000*HB)
    AX=SQR(LH*LH-.25*HA*HA)
    AX=AX-AX*A/HA
    PRINT:PRINT USING$("Horn axial length = ###.# mm";1000*AX)
    TH=LH-LH*A/HA:TE=AX
    PRINT
    PRINT USING$( "          H plane flare slant length = ###.# mm";1000*TH)
    PRINT USING$( "          E plane length             = ###.# mm";1000*TE)
    GOSUB 520:U1=SQR(LA*LH)/HA:U2=1/SQR(2)
    Z=(U1+1/U1)*U2:GOSUB 380
    CU=C:SU=S
    Z=(U1-1/U1)*U2:GOSUB 380
    GC=4*PI*HB*LH*((CU-C)^2+(SU-S)^2)
    GC=GC/(LA*HA)

    beamwidth = 180 / pi * ASIN(LA/ HA)
    bwnarrow =  300 / F * 51 / HB
    PRINT USING$( "          Beamwidth ~ #.###    ###",beamwidth, bwnarrow)
    PRINT
    PRINT USING$( "          Calculated gain               ##.# dB";10*LOG10(GC))

    X0 = 30  :  X1 = 70 :  X2 = 90  : X3 = 100         'H-Plane horn image
    Y0 = 30  :  Y1 = 40 :  Y2 = 100 : Y3 = 96
    title$ = USING$("H-Plane Sectoral ###.## GHz  WG##   Gain ##.# dB   Beamwidth E ~ ##  H ~ ###",F/ 1000, WG%,10*LOG10(GC), Beamwidth, bwnarrow)

    lsidea = SQR(((ha - a) / 2) ^ 2 + te ^ 2)
    lsideb = SQR(((hb - b) / 2) ^ 2 + th ^ 2)    'both these should be the same!!
    GOSUB drawing
    GOSUB cutting
    PRINT "------------------------------------"
    PRINT "  [esc] to end"
    DO
        ik$ = WAITKEY$
        IF ik$ = CHR$(27) THEN EXIT LOOP
    LOOP
    END

    REM WAVEGUIDE DATA
    DATA 6,6.5,3.25,1.12,1.7
    DATA 8,4.3,2.15,1.7,2.6
    DATA 10,2.x84,1.34,2.6,3.95
    DATA 12,1.872,0.872,3.95,5.85
    DATA 14,1.372,0.622,5.85,8.2
    DATA 16,0.9,0.4,8.2,12.4
    DATA 18,0.622,0.311,12.4,18.0
    DATA 20,0.42,0.17,18,26.5
    DATA 22,.28,.14,26.5,40
    DATA 24,.188,.094,40,60
    DATA 26,.122,.061,60,90
    DATA 28,.08,.04,90,140
    REM FRESNEL INTEGRALS BY GAUSS INTEG.
    DATA 0.038770605,0.077505948
    DATA 0.116084071,0.077039818
    DATA 0.192697581,0.076110362
    DATA 0.268152185,0.074723169
    DATA 0.341994091,0.072886582
    DATA 0.413779204,0.070611647
    DATA 0.483075802,0.067912046
    DATA 0.549467125,0.064804013
    DATA 0.612553890,0.061306242
    DATA 0.671956685,0.057439769
    DATA 0.727318255,0.053227847
    DATA 0.778305651,0.048695808
    DATA 0.824612231,0.043870908
    DATA 0.865959503,0.038782168
    DATA 0.902098807,0.033460195
    DATA 0.932812808,0.027937007
    DATA 0.957916819,0.022245849
    DATA 0.977259950,0.016421058
    DATA 0.990726239,0.010498285
    DATA 0.998237710,0.004521277

drawing:
    GRAPHIC WINDOW NEW "3D View   (not to scale)"   , 30, 100  , 500 , 500 TO HW&
    GRAPHIC ATTACH HW&, 0
    GRAPHIC SCALE (0, 120) - (120 , 0)
    GRAPHIC SET POS (20,110)
    GRAPHIC PRINT "Dimensions  mm"

    GRAPHIC LINE (X0,Y0)-(X0,Y1)
    GRAPHIC LINE -(X1,Y1)
    GRAPHIC LINE -(X1,Y0)
    GRAPHIC LINE -(X0,Y0)
    GRAPHIC LINE (X0,Y1)-(X2,Y2)
    GRAPHIC LINE -(X3,Y2)
    GRAPHIC LINE (X1,Y1)-(X3,Y2)
    GRAPHIC LINE (X1,Y0)-(X3,Y3)
    GRAPHIC LINE -(X3,Y2)

    GRAPHIC COLOR %RED , -1
    GRAPHIC STYLE 3
    GRAPHIC LINE ((X0 + X1)/2,Y1)-((X2 + X3)/2,Y2)
    GRAPHIC LINE (X1,(Y0 + Y1)/2)-(X3,(Y2 + Y3)/2)

    GRAPHIC COLOR %BLUE
    GRAPHIC SET POS  ((X0+ X1)/2, Y0-3) : GRAPHIC PRINT USING$( "####.#";1000*ha)
    GRAPHIC SET POS  (X0-10, (Y0 + Y1)/2) : GRAPHIC PRINT USING$( "####.#";1000*hb)
    GRAPHIC SET POS (X2, Y2+ 5) : GRAPHIC PRINT USING$("###.#", A * 1000)
    GRAPHIC SET POS (X3+1, Y2): GRAPHIC PRINT USING$("###.#", B * 1000)

    GRAPHIC COLOR %RED
    GRAPHIC SET POS  ((X0 + X3)/2, (Y1 + Y2)/2 + 5) : GRAPHIC PRINT USING$( "####.#";1000*te)
    GRAPHIC SET POS  ((X1 + X3)/2, (Y1+Y3)/2) : GRAPHIC PRINT USING$( "####.#";1000*th)

    GRAPHIC COLOR %MAGENTA
    GRAPHIC SET POS  ((X1 + X3)/2, Y1) : GRAPHIC PRINT USING$( "Edge ####.#";1000*lsidea)

    GRAPHIC COLOR RGB(0,80,80)
    GRAPHIC SET POS (5 , 5) : GRAPHIC PRINT title$
RETURN

drawcone:
    GRAPHIC WINDOW NEW "3D View   (not to scale)"   , 100, 100  , 500 , 500 TO HW&
    GRAPHIC ATTACH HW&, 0
    GRAPHIC SCALE (0, 120) - (120 , 0)
    GRAPHIC SET POS (20,110)
    GRAPHIC PRINT "Dimensions  mm"

    GRAPHIC ELLIPSE (30,30) - (60,70)
    GRAPHIC STYLE 2
    GRAPHIC LINE(45,70) -  (90,65)
    GRAPHIC LINE(55,35) -  (92,65)

    GRAPHIC COLOR %BLUE
    GRAPHIC SET POS (25,50)
    GRAPHIC PRINT USING$("Diameter ###.#",1000*D)
    GRAPHIC SET POS (60,75)
    GRAPHIC PRINT USING$("L = ###.#",1000*L)

    GRAPHIC COLOR RGB(0,80,80)
    GRAPHIC SET POS (5 , 5) : GRAPHIC PRINT title$
RETURN

cutting:
    GRAPHIC WINDOW NEW "Half - Cutting Template"   , 550, 100  , 500 , 500 TO HW2&
    GRAPHIC ATTACH HW2&, 0
    GRAPHIC SCALE (-100, 650) - (650,-100)
    GRAPHIC SET POS (60 , 590)
    GRAPHIC PRINT "HALF CUTTING TEMPLATE  (X , Y) Coordinates,  mm";

    theta1 = ATN((ha - a) / 2 / te)
    theta2 = ATN((hb - b) / 2 / th)
    theta = theta1 + theta2
    e = ABS(lsidea - lsideb)

    p1x = 0
    p1y = ha
    p2x = te
    p2y = (ha + a) / 2
    p3x = te
    p3y = (ha - a) / 2

    p4x = hb * SIN(theta)
    p4y = ha + hb * COS(theta)
    p5x = te + b * SIN(theta)
    p5y = (ha + a) /2 + b * COS(theta)

    COLOR 3
    PRINT "   Half - Cutting Coordinates"
    PRINT USING$("   2nd side rotation  ###.#",theta * 180 /pi)
    PRINT        "     0.0 ,   0,0"
    PRINT USING$("   ###.# , ###.#", p1x * 1000,p1y * 1000)
    PRINT USING$("   ###.# , ###.#", p2x * 1000,p2y * 1000)
    PRINT USING$("   ###.# , ###.#", p3x * 1000,p3y * 1000)
    PRINT USING$("   ###.# , ###.#", p4x * 1000,p4y * 1000)
    PRINT USING$("   ###.# , ###.#", p5x * 1000,p5y * 1000)
    COLOR 7

    maxx = MAX (plx, p2x, p3x, p4x, p5x)
    maxy = MAX (ply, p2y, p3y, p4y, p5y)
    maxdim = MAX(maxx, maxy)
 '   maxdim = MAX(p1x , p1y , p2x , p2y , p3x , p3y , p4x , p4y , p5x , p5y)
    sf = 500 / maxdim

    GRAPHIC SET POS (60 , 560)
    GRAPHIC PRINT USING$("Minimum sheet size ####  x  ####", maxx * 1000 +5 , maxy * 1000 + 5)

    LineCol& = RGB(140,140,140)
    GRAPHIC WIDTH 1
    GRAPHIC STYLE 2
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (0,0) - (-80 , 0)
    GRAPHIC COLOR 0, -2 : GRAPHIC PRINT "0"
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p1x * sf , p1y * sf) - (580 , p1y * sf)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p1y * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p2x * sf , p2y * sf) - (520 , p2y * sf)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p2y * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p3x * sf , p3y * sf) - (520 , p3y * sf)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p3y * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p4x * sf , p4y * sf) - (580 , p4y * sf)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p4y * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p5x * sf , p5y * sf) - (580 , p5y * sf)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p5y * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (0 ,0) - (0, -40)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT "0"
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p3x * sf , p3y * sf) - (p3x * sf, -50)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p3x * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p4x * sf , p4y * sf) - (p4x * sf, -30)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p4x * 1000, 1)
    GRAPHIC COLOR LineCol&, -2 : GRAPHIC LINE (p5x * sf , p5y * sf) - (p5x * sf, -10)
    GRAPHIC COLOR 0, -2: GRAPHIC PRINT ROUND(p5x * 1000, 1)

    GRAPHIC COLOR %BLUE , -2
    GRAPHIC SET POS(p3x / 2 * sf , p3y / 2 * sf)
    GRAPHIC PRINT USING$("####.#" , lsidea * 1000)
    GRAPHIC SET POS(0 , p1y / 2 * sf)
    GRAPHIC PRINT USING$("####.#" , ha * 1000)
    GRAPHIC SET POS(p4x / 2 * sf  , (p1y + p4y) / 2 * sf)
    GRAPHIC PRINT USING$("####.#" , hb * 1000)

    GRAPHIC SET POS(550, 10)
    GRAPHIC PRINT USING$("A = ####.#" , a * 1000)
    GRAPHIC SET POS(550, 30)
    GRAPHIC PRINT USING$("B = ####.#" , b * 1000)

    GRAPHIC STYLE 0
    GRAPHIC WIDTH 2
    GRAPHIC COLOR %BLACK
    GRAPHIC  LINE (0 , 0) - (p1x * sf , p1y * sf)
    GRAPHIC  LINE - (p2x * sf , p2y * sf)
    GRAPHIC  LINE - (p3x * sf , p3y * sf)
    GRAPHIC  LINE - (0 , 0)
    GRAPHIC  LINE (p1x * sf , p1y * sf) - (p4x * sf , p4y * sf)
    GRAPHIC  LINE - (p5x * sf , p5y * sf)
    GRAPHIC  LINE - (p2x * sf , p2y * sf)
RETURN

CutCone:
    GRAPHIC WINDOW NEW "Conical Horn Cutting Template"   , 620, 100  , 500 , 500 TO HW2&
    GRAPHIC ATTACH HW2&, 0
    GRAPHIC SCALE (-20, 540) - (520,-20)
    GRAPHIC SET POS (60 , 530)
    GRAPHIC PRINT "CONICAL HORN CUTTING TEMPLATE    mm";

    GRAPHIC STYLE 2
    GRAPHIC COLOR %GRAY
    GRAPHIC ELLIPSE   (0, 0) - (500, 500)
    GRAPHIC STYLE 3
    GRAPHIC LINE (250 , 250) - (250 ,0)

    th = pi / 180 * (90 - CutOutAngle / 2)
    endpointx = 250 * COS(th)
    endpointy = 250 * SIN(th)
    GRAPHIC STYLE 3
    GRAPHIC LINE (250 - endpointx , 250 + endpointy) - (250 + endpointx, 250 + endpointy)
    GRAPHIC COLOR %RED
    GRAPHIC SET POS (230,310)
    GRAPHIC PRINT USING$("Angle ###.#",CutOutAngle)
    GRAPHIC SET POS (240,230)
    GRAPHIC PRINT USING$("###.#",360 -CutOutAngle)

    GRAPHIC COLOR %BLUE
    GRAPHIC SET POS (253 , 170)
    GRAPHIC PRINT USING$("Radius ####.#mm", L * 1000 )
    GRAPHIC SET POS(100  , 248 + endpointy)
    GRAPHIC PRINT USING$("####.#mm",L * 2000 * COS(th))
    GRAPHIC COLOR %BLACK
    GRAPHIC SET POS (60 , 515)
    IF CutOutAngle > 180 THEN maxy = L * 1000 * (1 + ABS(SIN(th))) ELSE maxy = L * 1000
    GRAPHIC PRINT USING$("Minimum sheet size ####  x  ####",  L * 2000 * COS(th) + 5, maxy + 5)


    GRAPHIC STYLE 0
    GRAPHIC WIDTH 2
    GRAPHIC COLOR %BLACK
    GRAPHIC SET POS (250,250)
    FOR deg = 90-CutOutAngle / 2 TO 90 + CutOutAngle /2 STEP .5
        th = pi / 180 * deg
        GRAPHIC LINE - (250 + 250 * COS(th), 250 + 250 * SIN(th))
    NEXT deg
    GRAPHIC LINE - (250, 250)
RETURN

END FUNCTION
